package rocks.zipcode;

import java.io.*;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author leon on 16/11/2018.
 */
public class Document implements DocumentInterface {

    private final FileWriter fileWriter;
    private final File file;

    public Document(String fileName) throws IOException {
        this(new File(fileName));
    }

    public Document(File file) throws IOException {
        this.file = file;
        this.fileWriter = new FileWriter(file);
    }

    @Override
    public void write(String contentToBeWritten) {
        try {
            fileWriter.write(contentToBeWritten);
            fileWriter.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }


    }

    @Override
    public void write(Integer lineNumber, String valueToBeWritten) {
        List <String> lines = null;
        try {
            lines = Files.readAllLines(file.toPath());
            lines.set(lineNumber,valueToBeWritten);
            Files.write(file.toPath(), lines);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    @Override
    public String read(Integer lineNumber) {
        String lineToBeRead= null;
        try {
            lineToBeRead = Files
                    .readAllLines(Paths
                            .get("target/file.txt"))
                    .get(lineNumber);

        } catch (IOException e) {
            e.printStackTrace();
        }
        return lineToBeRead;
    }

    @Override
    public String read() {

        StringBuilder builder = new StringBuilder();
        try (BufferedReader br = new BufferedReader(new FileReader(file)))
        {

            String sCurrentLine;
            while ((sCurrentLine = br.readLine()) != null)
            {
                builder.append(sCurrentLine).append("\n");
            }
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        return builder.toString().trim();



//        try{
//            return new String (Files.readAllBytes(Paths.get(file.getName())));
//        } catch (IOException e) {
//            e.printStackTrace();
//            return null;
//        }

    }

    @Override
    public void replaceAll(String stringToReplace, String replacementString) {
        Path path = Paths.get("target/file.txt");
        Charset charset = StandardCharsets.UTF_8;

        String content = null;
        try {
            content = new String(Files.readAllBytes(path), charset);
        } catch (IOException e) {
            e.printStackTrace();
        }
        content = content.replaceAll(stringToReplace, replacementString);
        try {
            Files.write(path, content.getBytes(charset));
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    @Override
    public void overWrite(String content) {
        try {
            Writer fileWriter = new FileWriter("target/file.txt", false);
            write(content);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    public List<String> toList() {
        Scanner s = null;
        try {
            s = new Scanner(new File("target/file.txt"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        ArrayList<String> list = new ArrayList<>();
        while (s.hasNext()){
            list.add(s.next());
        }
        s.close();



        return list;
    }

    @Override
    public File getFile() {
         File f = new File("target/file.txt");
         return  file;

    }

    @Override
    public String toString() {
         String fileName = "target/file.txt";
        String content = "";

        try
        {
            content = new String ( Files.readAllBytes( Paths.get("target/file.txt") ) );

        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
        StringBuilder builder = new StringBuilder(fileName)
                .append('{')
                .append(content)
                .append('}');


        return builder.toString();

    }
}
